function Initialize()
{
	//SRR_CMI_INDICATOR_V1.01
	//Idea (c) Daniel Fernandez
	//Coded for AD 4.0 by SRR (aka Indigo-On), 2017-2018
	// Choppy Market Index - CMI
	//     0-100.
	//   ,    , 
	//,   .
	//       .
	// :
	//CMI = ((ABS(Close[0]-Close[n]))/(MaxHigh[n]-MinLow[n]))*100
	//:
	//ABS -  ;
	//Close[0] -  ;
	//Close[n] -  N  ;
	//MaxHigh[n] -   High   N ;
	//MinLow[n] -   Low   N .
	// : https://www.mql5.com/ru/market/product/3260#
	// : https://www.mql5.com/ru/code/942
	//
	// 2  
	//
	//v1.01	-	   .
	//v1.00	-	  .

	//   #1
	// :
	IndicatorName = "SRR_CMI_V1";		// 
	PriceStudy = false;					//   
	// :
 	AddParameter("Period", 60, 2);		// CMI (     D1 = 60)
	AddParameter("MA_Period", 10);		// SMA (   = 10)
	AddGlobalVariable("dSum", Types.Double, 0.0);		//      SMA
	AddGlobalVariable("iColorIndex", Types.Int, 0);		//      CMI
	//   Candle
	AddInput("Input1", Inputs.Candle);
 	//  #1  -    CMI
	AddSeries("CMI", DrawAs.Custom, Color.Silver, true);
 	//  #2  -    SMA
 	AddSeries("MySMA", DrawAs.Line, Color.Blue, true);
	//   
	AddLevel(40.0, Color.Silver, LineStyles.DashSmall, 1, "CMI");
	AddLevel(50.0, Color.Silver, LineStyles.DashSmall, 1, "CMI");
	AddLevel(60.0, Color.Silver, LineStyles.DashSmall, 1, "CMI");
}

function Evaluate()
{
	///////////////////////////////////////////////////////////
	///   
	///////////////////////////////////////////////////////////

	///////////////////////////////////////////////////////////
	///  CMI
	///     CMI
	///////////////////////////////////////////////////////////
	// 
	double dMin = 0.0;		//   
	double dMax = 0.0;		//   
	double dDeltaClose;		// 
	
	// CMI,     
	if (CurrentIndex > Period)
	{
		//    
		var eMin = 1000000000.0;
		for(int i = 0; i < Period; i++)
			if (Input.Low[-i] < eMin)
				eMin = Input.Low[-i];
		dMin = eMin;
		//    
		var eMax = 0.0;
		for(int i = 0; i < Period; i++)
			if (Input.High[-i] > eMax)
				eMax = Input.High[-i];
		dMax = eMax;
		// CMI
		CMI = ((Math.Abs(Input1.Close[0] - Input1.Close[-Period]))/(dMax - dMin)) * 100.0;
	}
	else
		CMI = 50.0;

	///////////////////////////////////////////////////////////
	///    CMI  
	///////////////////////////////////////////////////////////
	dDeltaClose = Input1.Close[0] - Input1.Close[-Period];
	if (dDeltaClose > 0.0)
	{
		if (iColorIndex < 2)
			iColorIndex++;

	}
	else
	{
		if (dDeltaClose < 0.0)
		{
			if (iColorIndex > 0)
				iColorIndex--;
		}
     	else
			iColorIndex = 1;
	}
	//  CMI     
	//  iColorIndex
	switch (iColorIndex)
	{
		case 0:
			//  
			CMI.DrawLine(Color.Red, Line.Solid, 1);
			break;
		case 1:
			//  
			CMI.DrawLine(Color.Yellow, Line.Solid, 1);
			break;
		case 2:
			//  
			CMI.DrawLine(Color.Green, Line.Solid, 1);
			break;
	}


	///////////////////////////////////////////////////////////
	///  SMA 
	///     MySMA
	///////////////////////////////////////////////////////////
	if (CurrentIndex < MA_Period)
	{
		dSum = dSum + CMI[0];
		MySMA = dSum / (CurrentIndex + 1);
	}
	else
	{
		dSum = dSum + CMI[0] - CMI[(int)(-MA_Period)];
		MySMA = dSum / MA_Period;
	}
	///////////////////////////////////////////////////////////
	///    SMA  
	///////////////////////////////////////////////////////////
}
